/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of XS.xs. Do not edit this file, edit XS.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "XS.xs"
#define PERL_NO_GET_CONTEXT
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "ppport.h"
#include <math.h>
#include <string.h>
#include "words.h"

#ifndef __bool_true_false_are_defined
#	define __bool_true_false_are_defined 1
#	define false 0
#	define true 1
#endif

#ifndef U64
typedef uint64_t U64;
#endif

#ifndef likely
#	define likely(x) __builtin_expect((x), 1)
#endif

#ifndef unlikely
#	define unlikely(x) __builtin_expect((x), 0)
#endif

/* Macro for choosing the ending corresponding to the specified value */
#define ending4value(value)                                          \
	((value) % 100 / 10 - 1) && (value) % 10 > 0 && (value) % 10 < 5 \
		? (value) % 10 > 1 ? COUPLE : SINGLE : SEVERAL

#define double2kopeck(value) \
	(U8) nearbyint(((value) - (U64) (value)) * 100) % 100

STATIC SV *
kopeck2words(pTHX_ U8 value, bool words) {
	U8 ending = ending4value(value);
	SV *value_pv = sv_2mortal(newSVpvs(""));
	if (words) {
		if (value % 100 < 20) {
			const char *word = strcmp(funits[value % 100], "") ? funits[value % 100] : zero;
			sv_catpvn(value_pv, word, strlen(word));
		} else {
			sv_catpvn(value_pv, tens[value % 100 / 10], strlen(tens[value % 100 / 10]));
			sv_catpvn(value_pv, funits[value % 10], strlen(funits[value % 10]));
		}
	} else {
		char value_str[4];
		sprintf(value_str, "%02d ", value);
		sv_catpvn(value_pv, value_str, strlen(value_str));
	}
	sv_catpvn(value_pv, kopeck[ending], strlen(kopeck[ending]));
	return value_pv;
}

STATIC SV *
ruble2words(pTHX_ U16 value, U8 decade, bool words) {
	U8 ending = ending4value(value);
	SV *value_pv = sv_2mortal(newSVpvs(""));
	if (!value) {
		if (!decade)
			sv_catpvn(value_pv, ruble[decade][ending], strlen(ruble[decade][ending]));
		return value_pv;
	}
	if (words) {
		sv_catpvn(value_pv, hundreds[value / 100], strlen(hundreds[value / 100]));
		char **units = (char **) (decade == THOUSAND ? funits : munits);
		if (value % 100 < 20) {
			sv_catpvn(value_pv, units[value % 100], strlen(units[value % 100]));
		} else {
			sv_catpvn(value_pv, tens[value % 100 / 10], strlen(tens[value % 100 / 10]));
			sv_catpvn(value_pv, units[value % 10], strlen(units[value % 10]));
		}
	} else {
		char value_str[5];
		sprintf(value_str, "%d ", value);
		sv_catpvn(value_pv, value_str, strlen(value_str));
	}
	sv_catpvn(value_pv, ruble[decade][ending], strlen(ruble[decade][ending]));
	return value_pv;
}

STATIC SV *
money2words(pTHX_ double amount, bool ruble_cvt, bool kopeck_cvt) {
	if (unlikely(amount < MONEY_MIN))
		croak("Negative amount can't be processed");
	if (unlikely(amount >= MONEY_MAX))
		croak("Given amount can't be processed due to the type overflow");
	if (unlikely(amount >= pow(1e3, TRILLION)))
		warn("Kopeck value is calculated inaccurate due to the lack for "
			"significant digits after the radix point");
	U8 kopeck_v = amount < pow(1e3, TRILLION) ? double2kopeck(amount) : 0;
	AV *stack = (AV *) sv_2mortal((SV *) newAV());
	av_push(stack, kopeck2words(aTHX_ kopeck_v, kopeck_cvt));
	U64 ruble_v = (U64) amount;
	U8 decade;
	for (decade = UNIT; ruble_v > 0; ruble_v /= 1000, decade++)
		av_push(stack, ruble2words(aTHX_ ruble_v % 1000, decade, ruble_cvt));
	/* Build the result string */
	SV *words = sv_2mortal(newSVpvs(""));
	while (av_len(stack) + 1)
		sv_catsv(words, av_pop(stack));
	SvUTF8_on(words);
	return words;
}

#line 118 "XS.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 262 "XS.c"

XS_EUPXS(XS_Lingua__RU__Money__XS_rur2words); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lingua__RU__Money__XS_rur2words)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "amount");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	amount = ST(0)
;
#line 114 "XS.xs"
		ST(0) = money2words(aTHX_ SvNV(amount), true, false);
		XSRETURN(1);
#line 278 "XS.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Lingua__RU__Money__XS_all2words); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lingua__RU__Money__XS_all2words)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "amount");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	amount = ST(0)
;
#line 121 "XS.xs"
		ST(0) = money2words(aTHX_ SvNV(amount), true, true);
		XSRETURN(1);
#line 299 "XS.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Lingua__RU__Money__XS); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Lingua__RU__Money__XS)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("Lingua::RU::Money::XS::rur2words", XS_Lingua__RU__Money__XS_rur2words, file, "$");
        (void)newXSproto_portable("Lingua::RU::Money::XS::all2words", XS_Lingua__RU__Money__XS_all2words, file, "$");
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
